#ifndef	USERDEFS_H
#define	USERDEFS_H

#ifdef	_Windows
#include	<windows.h>
#endif

#ifndef	_SWITCHSTATE
#define	_SWITCHSTATE
typedef	enum{OFF,ON} SWITCH;
#endif

#ifndef	_TRISTATE
#define	_TRISTATE
typedef	enum{LOW=-1,MID=0,HIGH=1} TRISTATE;
#endif

#ifndef	NUL
#define	NUL	'\0'
#endif

#ifndef	NIL
#define	NIL	(void *)0
#endif

#include	<float.h>

#if !defined(PTR)
#define	PTR __FAR *
#endif

#if defined(__TINY__)|| defined(__SMALL__)|| defined(__COMPACT__)
#define	__FAR	far
#endif

#if	 defined(__LARGE__)|| defined(__HUGE__)
#define	__FAR	__far
#endif

#if !defined(_Windows)
#if !defined(_BOOL)

typedef enum {FALSE,TRUE} BOOL;

#endif
#endif

#if !defined(BYTE)
typedef	unsigned char BYTE;
#endif

#if !defined(WORD)&&!defined(_Windows)
typedef	unsigned int WORD;
#endif

#ifndef	_ESCAPES
#define	_ESCAPES
enum escapes{	BELL='\a',BACKSPACE='\b',TAB='\t',NL='\n',VTAB='\v',
							CR='\r'};
#endif

#ifdef __STDC__

#ifndef	min
#define	min(A,B)	((A)<(B)?(A):(B))
#endif
#ifndef	max
#define	max(A,B)	((A)>(B)?(A):(B))
#endif
#ifndef	lround
#if FLT_DIG==6
#define	FSCALE	1.0E+6f
#elif	FLT_DIG==5
#define	FSCALE	1.0E+5f
#elif	FLT_DIG==7
#define	FSCALE	1.0E+7f
#elif	FLT_DIG==8
#define	FSCALE	1.0E+8f
#elif	FLT_DIG==4
#define	FSCALE	1.0E+4f
#elif	FLT_DIG==9
#define	FSCALE	1.0E+9f
#endif
#define	lround(X)	(long)(((X)*FSCALE)+0.5f)
#endif
#endif
#ifndef	sign
#define	sign(X) ((X)<0?(-1):(1))
#endif


#endif
